﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Diagrams;

namespace WPFTest
{
	/// <summary>
	/// 
	/// </summary>
	public class MyShape : RadDiagramShapeBase
	{
		public static readonly DependencyProperty ImageSourceProperty =
			DependencyProperty.Register("ImageSource", typeof(ImageSource), typeof(MyShape), new PropertyMetadata(null));

		static MyShape()
		{
			DefaultStyleKeyProperty.OverrideMetadata(typeof(MyShape), new FrameworkPropertyMetadata(typeof(MyShape)));
		}

		public MyShape()
		{
			this.CreateImageWithDrawingGroup();

			//if you want you could use this one:
			//this.CreateImageWithDrawingVisual();
		}

		private void CreateImageWithDrawingVisual()
		{
			var drawingVisual = new DrawingVisual();
			GeometryDrawing geometry = new GeometryDrawing(Brushes.Orange, new Pen(Brushes.Red, 2), new RectangleGeometry(new Rect(2, 2, 56, 56)));
			using (var drawingContext = drawingVisual.RenderOpen())
			{
				drawingContext.DrawDrawing(geometry);
			}
			RenderTargetBitmap bmp = new RenderTargetBitmap(60, 60, 96, 96, PixelFormats.Pbgra32);
			bmp.Render(drawingVisual);
			this.ImageSource = bmp;
		}

		private void CreateImageWithDrawingGroup()
		{
			GeometryDrawing ellipseDrawing =
			   new GeometryDrawing(
				   new SolidColorBrush(Color.FromArgb(102, 181, 243, 20)),
				   new Pen(Brushes.Black, 4),
				   new EllipseGeometry(new Point(50, 50), 50, 50)
			   );

			GeometryDrawing rectangleDrawing =
			   new GeometryDrawing(
				   new SolidColorBrush(Color.FromArgb(123, 44, 123, 120)),
				   new Pen(Brushes.Black, 4),
				   new RectangleGeometry(new Rect(new Point(75, 75), new Point(125, 125)))
			   );

			GeometryDrawing ellipseDrawing2 =
				new GeometryDrawing(
					new SolidColorBrush(Color.FromArgb(102, 181, 243, 20)),
					new Pen(Brushes.Black, 4),
					new EllipseGeometry(new Point(150, 150), 50, 50)
				);

			DrawingGroup aDrawingGroup = new DrawingGroup();
			aDrawingGroup.Children.Add(ellipseDrawing);
			aDrawingGroup.Children.Add(rectangleDrawing);
			aDrawingGroup.Children.Add(ellipseDrawing2);

			DrawingImage image = new DrawingImage(aDrawingGroup);
			this.ImageSource = image;
		}

		public ImageSource ImageSource
		{
			get { return (ImageSource)GetValue(ImageSourceProperty); }
			set { SetValue(ImageSourceProperty, value); }
		}
	}
}
